         .include "ti-85.h"

score    =$80df         ; the score!
ll       =$80e5
rl       =$80f5
rptr     =$8200

         .org     $8641

         .db      "Z-Kart 0 by Patrick D",0

         ld       hl,(PROGRAM_ADDR)
         ld       de,$8641
         ld       bc,end-$8641
         ldir
zkart:   ld       a,4
         out      (5),a         ; graphics mode
         ld       (iy+13),0

         ROM_CALL(CLEARLCD)
         ld       hl,$0007
         ld       ($800c),hl
         ld       hl,message
         ROM_CALL(D_ZT_STR)     ; display co-byline


         ld       hl,$80e5
         
         ld       a,32
         ld       b,16
lleft:   ld       (hl),a
         inc      hl
         djnz     lleft
         ld       a,96
         ld       b,16
lright:  ld       (hl),a
         inc      hl
         djnz     lright
loop:    ld       bc,1550
wait:    dec      bc
         ld       a,b
         or       c
         jr       nz,wait
         ld       c,25
         ld       a,(x)
         ld       b,a
         call     ptoff
         dec      b
         call     ptoff
         inc      b
         inc      b
         call     ptoff
         dec      b
         inc      c
         call     ptoff
         dec      c
         dec      c
         call     ptoff
         ld       de,$fc70
         ld       hl,$fc80
         ld       bc,768
         ldir
         ld       hl,880+$fc00
         ld       b,16
         ld       a,0
lclr:    ld       (hl),a
         inc      hl
         djnz     lclr
         ld       hl,l

         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       b,a
         ld       c,8
         CALL     pton
         inc      hl
         ld       a,(hl)
         inc      hl
         add      a,(hl)
         dec      hl
         ld       (hl),a
         ld       b,a
         ld       c,8
         CALL     pton
         ld       a,%01111110
         out      (1),a
         in       a,(1)
         bit      1,a
         dec      hl
         dec      hl
         jr       nz,no_left
         dec      (hl)
no_left: bit      2,a
         jr       nz,no_right
         inc      (hl)
no_right:ld       a,(hl)
         ld       b,a
         ld       c,25
         call     pton
         dec      b
         call     pton
         inc      b
         inc      b
         call     pton
         dec      b
         inc      c
         call     pton
         dec      c
         dec      c
         call     pton
         ld       hl,$1007
         ld       ($800c),hl
         ld       hl,(score)
         inc      hl
         ld       (score),hl
         ROM_CALL(D_HL_DECI)
         ld       hl,(rptr)
         inc      hl
         res      7,h
         ld       (rptr),hl
        
         ld       a,(hl)
         cp       8
         jr       NC,nocc
         ld       hl,dirs
         and      7
         ld       e,a
         ld       d,0
         ADD      hl,de
         ld       a,(hl)
         ld       (v),a
nocc:    ld       hl,l
         ld       a,(hl)
         inc      hl
         cp       10
         jr       nz,noleftb
         inc      hl
         ld       (hl),1
         dec      hl
noleftb: ld       a,(hl)
         inc      hl
         cp       116
         jr       nz,norightb
         ld       (hl),-1
norightb:ld       hl,x
         ld       a,(ll)
         sub      (hl)
         rla
         jr       nc,lose
         ld       a,(rl)
         sub      (hl)
         rla
         jr       c,lose
         ld       hl,$80e6
         ld       de,$80e5
         ld       bc,32
         ldir
         ld       a,%00111111
         out      (1),a
         in       a,(1)
         bit      6,a
         ret      z

         ld       hl,l
         ld       a,(hl)
         ld       (ll+15),a
         inc      hl
         ld       a,(hl)
         ld       (rl+15),a
         ld       a,(score)
         and      63
         jr       nz,jloop
         dec      (hl)
         dec      hl
         inc      (hl)
jloop:   jp       loop
lose:    ld       hl,0
         ld       ($800c),hl
         ld       hl,lose_
         ROM_CALL(D_ZT_STR)
lwk:     call     GET_KEY
         cp       9
         jr       nz,lwk
         ret
lose_:   .db      "LOSER!!!  Press ENTER",0
message: .db      "Z-Kart 0  Score:",0
ptoff:   ROM_CALL(FIND_PIXEL)       ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into graphics memory   
         cpl                        ;Invert the accumulator
         and      (hl)              ;A now contains the modified screen byte
         ld       (hl),a            ;Write back to screen to update
         ret
pton:    push     hl
         ROM_CALL(FIND_PIXEL)       ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into the graphics memory
         or       (HL)              ;A now contains the modified screen byte
         ld       (HL),A            ;Write back to screen to update
         pop      hl
         ret
dirs:    .db      -1,1,-1,1,-1,1,0,0
x:       .db      64
l:       .db      32
r:       .DB      96
v:       .db      0
end:     .end
