         .include "ti-85.h"

score    =$80df         ; the score!
x        =$80e1         ; x pos
l        =$80e2
r        =$80e3
v        =$80E4
ll       =$80e5
rl       =$80f5
speed    =$8140

         .org     $8641

         .db      "High : "
digits:  .db      "0000"
         .db      " by "
name:    .db      "PATRICK D",0          ; zero terminated title

         ld       hl,(PROGRAM_ADDR)
         ld       de,$8641
         ld       bc,end-$8641
         ldir
         call     zkart
         ld       hl,$8641
         ld       de,(PROGRAM_ADDR)
         ld       bc,end-$8641
         ldir
         ret

zkart:   ld       a,4
         out      (5),a         ; graphics mode
         ld       a,1
         ld       (ZS_BITS),a

         ld       (iy+13),0

         ROM_CALL(CLEARLCD)
         ld       hl,0
         ld       ($800c),hl
         ld       hl,title_message
         ROM_CALL(D_ZT_STR)

loopttl: call     GET_KEY
         cp       K_F1
         jr       z,speed_1
         cp       K_F2
         jr       z,speed_2
         cp       K_F3
         jr       z,speed_3
         cp       K_F4
         jr       z,speed_4
         cp       K_F5
         jr       z,speed_5
         cp       K_EXIT
         jr       nz,loopttl
         ret
title_message:
         .db      "Z-Kart    Version 7.0"
         .db      " by Patrick Davidson "
         .db      "  (ariwsi@juno.com)  "
         .db      "Choose Speed : F1-F5",0
speed_1: ld       hl,0
         ld       de,3000
         jr       start
speed_2: ld       hl,100
         ld       de,2400
         jr       start
speed_3: ld       hl,200
         ld       de,1800
         jr       start
speed_4: ld       hl,300
         ld       de,1200
         jr       start
speed_5: ld       hl,400
         ld       de,600
start:   ld       (score),hl
         ld       (speed),de

         ROM_CALL(CLEARLCD)
         ld       hl,$0007
         ld       ($800c),hl
         ld       hl,message
         ROM_CALL(D_ZT_STR)     ; display co-byline


         ld       hl,$80e1
         ld       (hl),64
         inc      hl
         ld       (hl),32
         inc      hl
         ld       (hl),96
         inc      hl
         inc      hl
         
         ld       a,32
         ld       b,16
lleft:   ld       (hl),a
         inc      hl
         djnz     lleft
         ld       a,96
         ld       b,16
lright:  ld       (hl),a
         inc      hl
         djnz     lright
         ld       hl,0
         ld       ($8333),hl
         ld       hl,author_msg
         ROM_CALL(D_ZM_STR)
loop:    ld       bc,(speed)
wait:    dec      bc
         ld       a,b
         or       c
         jr       nz,wait
         ld       c,25
         ld       a,(x)
         ld       b,a
         call     ptoff
         dec      b
         call     ptoff
         inc      b
         inc      b
         call     ptoff
         dec      b
         inc      c
         call     ptoff
         dec      c
         dec      c
         call     ptoff)
         ld       de,$fc70
         ld       hl,$fc80
         ld       bc,768
         ldir
         ld       hl,880+$fc00
         ld       b,16
         ld       a,0
lclr:    ld       (hl),a
         inc      hl
         djnz     lclr
         ld       hl,l

         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       b,a
         ld       c,8
         CALL     pton
         inc      hl
         ld       a,(hl)
         inc      hl
         add      a,(hl)
         dec      hl
         ld       (hl),a
         ld       b,a
         ld       c,8
         CALL     pton
         ld       a,%01111110
         out      (1),a
         in       a,(1)
         bit      1,a
         dec      hl
         dec      hl
         jr       nz,no_left
         dec      (hl)
no_left: bit      2,a
         jr       nz,no_right
         inc      (hl)
no_right:ld       a,(hl)
         ld       b,a
         ld       c,25
         call     pton
         dec      b
         call     pton
         inc      b
         inc      b
         call     pton
         dec      b
         inc      c
         call     pton
         dec      c
         dec      c
         call     pton
         ld       hl,$1007
         ld       ($800c),hl
         ld       hl,(score)
         inc      hl
         ld       (score),hl
         ROM_CALL(D_HL_DECI)
         ld       hl,(rptr)
         inc      hl
         res      7,h
         ld       (rptr),hl
        
         ld       a,(hl)
         cp       8
         jr       NC,nocc
         ld       hl,dirs
         and      7
         ld       e,a
         ld       d,0
         ADD      hl,de
         ld       a,(hl)
         ld       (v),a
nocc:    ld       hl,l
         ld       a,(hl)
         inc      hl
         cp       10
         jr       nz,noleftb
         inc      hl
         ld       (hl),1
         dec      hl
noleftb: ld       a,(hl)
         inc      hl
         cp       116
         jr       nz,norightb
         ld       (hl),-1
norightb:ld       hl,x
         ld       a,(ll)
         sub      (hl)
         rla
         jr       nc,lose
         ld       a,(rl)
         sub      (hl)
         rla
         jr       c,lose
         ld       hl,$80e6
         ld       de,$80e5
         ld       bc,32
         ldir
         ld       a,%00111111
         out      (1),a
         in       a,(1)
         bit      6,a
         ret      z

         ld       hl,l
         ld       a,(hl)
         ld       (ll+15),a
         inc      hl
         ld       a,(hl)
         ld       (rl+15),a
         ld       a,(score)
         and      63
         jr       nz,jloop
         dec      (hl)
         dec      hl
         inc      (hl)
jloop:   jp       loop
lose:
         ld       hl,(best)
         ld       de,(score)
         CALL     CP_HL_DE
         jr       c,hisc
         ld       hl,0
         ld       ($800c),hl
         ld       hl,lose_
         ROM_CALL(D_ZT_STR)
lwk:     call     GET_KEY
         cp       9
         jr       nz,lwk
         ret
hisc:
         ld       de,(score)
         ld       (best),de
         ld       de,digits+3
         ld       hl,(score)
         ld       b,4
p_l:     CALL     UNPACK_HL
         add      a,'0'
         ld       (de),a
         dec      de
         djnz     p_l
         ld       hl,0
         ld       ($800c),hl
         ld       hl,hi_msg
         ROM_CALL(D_ZT_STR)
         ld       hl,$b00
         ld       ($800c),hl
         ld       hl, name
         push     hl
         ld       b,9
space_loop:
         ld       (hl), ' '
         inc      hl
         djnz     space_loop
         pop      ix
         ld       b,0
enter_name_loop:
         CALL     GET_KEY
         or       A
         jr       z,enter_name_loop
         cp       32
         jr       z,backup
         SUB      9
         jr       z,nomore
         dec      a
         bit      7,a
         jr       c,enter_name_loop
         ld       hl,chartable
         ld       e,a
         ld       d,0
         add      hl,de
         ld       a,9
         cp       b
         jr       z,enter_name_loop
         ld       a,(hl)
         or       a
         jr       z,enter_name_loop
         ld       (ix),a
         ROM_CALL(TX_CHARPUT)
         inc      b
         inc      ix
         jr       enter_name_loop
backup:  xor      a
         cp       b
         jr       z,too_far
         dec      b
         dec      ix
         ld       a,'_'

         ld       (ix),a
         ld       hl,$800d
         dec      (hl)
         ROM_CALL(TX_CHARPUT)
         dec      (hl)
         jr       enter_name_loop
too_far: inc      b
         jr       enter_name_loop
nomore:  ret
hi_msg:  .db      "Highscore! _________ ",0
lose_:   .db      "LOSER!!!  Press ENTER",0
message: .db      "Z-Kart 7  Score:"
         .db      0
ptoff:   ROM_CALL(FIND_PIXEL)       ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into graphics memory   
         cpl                        ;Invert the accumulator
         and      (hl)              ;A now contains the modified screen byte
         ld       (hl),a            ;Write back to screen to update
         ret
pton:    push     hl
         ROM_CALL(FIND_PIXEL)       ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into the graphics memory
         or       (HL)              ;A now contains the modified screen byte
         ld       (HL),A            ;Write back to screen to update
         pop      hl
         ret
dirs:    .db      -1,1,-1,1,-1,1,0,0
rptr:    .dw      0
chartable:
         .db      "XTOJE",0
         .db      0," WSNID!",0,"ZVRMHC?"
         .db      0,"YUQLGB#x~+PKFA|"
         .db      "@54321.~+"
best:    .dw      0
author_msg:
         .db      "By Patrick Davidson "
         .db      "& Jim Reardon",0
end:     .end
